Index: issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.cpp
===================================================================
--- issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.cpp	(revision 26744)
@@ -3,4 +3,5 @@
  */
 
+#include <config.h>
 #include "./SurfaceMassBalancex.h"
 #include "../../shared/shared.h"
@@ -8,4 +9,5 @@
 #include "../modules.h"
 #include "../../classes/Inputs/TransientInput.h"
+#include "../../shared/Random/random.h"
 
 void SmbForcingx(FemModel* femmodel){/*{{{*/
@@ -14,56 +16,4 @@
 	//    INPUT parameters: ni: working size of arrays
 	//    OUTPUT: mass-balance (m/yr ice): agd(NA)
-	bool isclimatology;
-	femmodel->parameters->FindParam(&isclimatology,SmbIsclimatologyEnum);
-
-	if (isclimatology){
-
-		/*Get time parameters*/
-		IssmDouble time,dt,starttime,finaltime;
-		femmodel->parameters->FindParam(&time,TimeEnum);
-		femmodel->parameters->FindParam(&dt,TimesteppingTimeStepEnum);
-		femmodel->parameters->FindParam(&finaltime,TimesteppingFinalTimeEnum);
-		femmodel->parameters->FindParam(&starttime,TimesteppingStartTimeEnum);
-
-		if(time<=starttime+dt){
-			/*FIXME: this is wrong, should be done at the ElementUpdate step of analysis, not here!*/
-			InputDuplicatex(femmodel,SmbMassBalanceEnum,SmbMassBalanceClimateEnum);
-			femmodel->inputs->DeleteInput(SmbMassBalanceEnum);
-		}
-
-		/*If this is a climatology, we need to repeat the forcing after the final time*/
-		TransientInput* smb_input=femmodel->inputs->GetTransientInput(SmbMassBalanceClimateEnum); _assert_(smb_input);
-
-		/*Get accumulation climatology value*/
-		int offsetend = smb_input->GetTimeInputOffset(finaltime);
-		IssmDouble time0     = smb_input->GetTimeByOffset(-1);
-		IssmDouble timeend   = smb_input->GetTimeByOffset(offsetend);
-
-		_assert_(timeend>time0);
-		IssmDouble timeclim  = time;
-
-		if(time>time0 && timeend>time0){
-			IssmDouble delta=(time-time0) - (timeend-time0)*(reCast<int,IssmDouble>((time-time0)/(timeend-time0)));
-			if(delta==0.){
-				timeclim=timeend;
-			}
-			else{
-				timeclim=time0+delta;
-			}
-		}
-
-		/*Loop over all the elements of this partition*/
-		for(Object* & object : femmodel->elements->objects){
-			Element* element=xDynamicCast<Element*>(object);
-
-			int         numvertices = element->GetNumberOfVertices();
-			IssmDouble* smb         = xNew<IssmDouble>(numvertices);
-			element->GetInputListOnVerticesAtTime(smb,SmbMassBalanceClimateEnum,timeclim);
-
-			/*Add input to element and Free memory*/
-			element->AddInput(SmbMassBalanceEnum,smb,P1Enum);
-			xDelete<IssmDouble>(smb);
-		}
-	}
 
 }/*}}}*/
@@ -196,4 +146,93 @@
 	}
 
+}/*}}}*/
+void SmbautoregressionInitx(FemModel* femmodel){/*{{{*/
+	
+	/*Initialization step of Smbautoregressionx*/
+	int M,N,Nphi,arorder,numbasins,my_rank;
+	IssmDouble starttime,tstep_ar,tinit_ar;
+	femmodel->parameters->FindParam(&numbasins,SmbNumBasinsEnum);
+	femmodel->parameters->FindParam(&arorder,SmbAutoregressiveOrderEnum);
+	IssmDouble* beta0    = NULL; 
+	IssmDouble* beta1    = NULL;
+	IssmDouble* phi      = NULL;
+	femmodel->parameters->FindParam(&starttime,TimesteppingStartTimeEnum);
+   femmodel->parameters->FindParam(&tstep_ar,SmbAutoregressionTimestepEnum);
+	femmodel->parameters->FindParam(&tinit_ar,SmbAutoregressionInitialTimeEnum);
+	femmodel->parameters->FindParam(&beta0,&M,SmbBeta0Enum);    _assert_(M==numbasins);
+	femmodel->parameters->FindParam(&beta1,&M,SmbBeta1Enum);    _assert_(M==numbasins);
+	femmodel->parameters->FindParam(&phi,&M,&Nphi,SmbPhiEnum);  _assert_(M==numbasins); _assert_(Nphi==arorder);
+	
+	/*AR model spin-up with 0 noise to initialize SmbValuesAutoregressionEnum*/
+	int nspin{2*arorder+5};
+	for(Object* &object:femmodel->elements->objects){
+      Element* element      = xDynamicCast<Element*>(object); //generate element object
+		element->AutoregressionInit(numbasins,arorder,nspin,starttime,tstep_ar,tinit_ar,beta0,beta1,phi,SMBautoregressionEnum);
+	}
+	/*Cleanup*/
+	xDelete<IssmDouble>(beta0);
+	xDelete<IssmDouble>(beta1);
+	xDelete<IssmDouble>(phi);
+}/*}}}*/
+void Smbautoregressionx(FemModel* femmodel){/*{{{*/
+
+   /*Get time parameters*/
+   IssmDouble time,dt,starttime,tstep_ar;
+   femmodel->parameters->FindParam(&time,TimeEnum);
+   femmodel->parameters->FindParam(&dt,TimesteppingTimeStepEnum);
+   femmodel->parameters->FindParam(&starttime,TimesteppingStartTimeEnum);
+   femmodel->parameters->FindParam(&tstep_ar,SmbAutoregressionTimestepEnum);
+
+   /*Initialize module at first time step*/
+   if(time<=starttime+dt){SmbautoregressionInitx(femmodel);}
+   /*Determine if this is a time step for the AR model*/
+   bool isstepforar = false;
+
+   #ifndef _HAVE_AD_
+   if((fmod(time,tstep_ar)<fmod((time-dt),tstep_ar)) || (time<=starttime+dt) || tstep_ar==dt) isstepforar = true;
+   #else
+   _error_("not implemented yet");
+   #endif
+
+   /*Load parameters*/
+   bool isstochastic;
+   bool issmbstochastic = false;
+   int M,N,Nphi,arorder,numbasins,my_rank;
+   femmodel->parameters->FindParam(&numbasins,SmbNumBasinsEnum);
+   femmodel->parameters->FindParam(&arorder,SmbAutoregressiveOrderEnum);
+   IssmDouble tinit_ar;
+   IssmDouble* beta0      = NULL; 
+   IssmDouble* beta1      = NULL;
+   IssmDouble* phi        = NULL;
+
+   femmodel->parameters->FindParam(&tinit_ar,SmbAutoregressionInitialTimeEnum);
+   femmodel->parameters->FindParam(&beta0,&M,SmbBeta0Enum);    _assert_(M==numbasins);
+   femmodel->parameters->FindParam(&beta1,&M,SmbBeta1Enum);    _assert_(M==numbasins);
+   femmodel->parameters->FindParam(&phi,&M,&Nphi,SmbPhiEnum);  _assert_(M==numbasins); _assert_(Nphi==arorder);
+
+   femmodel->parameters->FindParam(&isstochastic,StochasticForcingIsStochasticForcingEnum);
+   if(isstochastic){
+      int  numstochasticfields;
+      int* stochasticfields;
+      femmodel->parameters->FindParam(&numstochasticfields,StochasticForcingNumFieldsEnum);
+      femmodel->parameters->FindParam(&stochasticfields,&N,StochasticForcingFieldsEnum); _assert_(N==numstochasticfields);
+      for(int i=0;i<numstochasticfields;i++){
+         if(stochasticfields[i]==SMBautoregressionEnum) issmbstochastic = true;
+      }
+      xDelete<int>(stochasticfields);
+   }
+   /*Time elapsed with respect to AR model initial time*/
+   IssmDouble telapsed_ar = time-tinit_ar;
+
+   /*Loop over each element to compute SMB at vertices*/
+   for(Object* &object:femmodel->elements->objects){
+      Element* element = xDynamicCast<Element*>(object);
+      element->Autoregression(isstepforar,arorder,telapsed_ar,beta0,beta1,phi,issmbstochastic,SMBautoregressionEnum);
+   }
+
+   /*Cleanup*/
+   xDelete<IssmDouble>(beta0);
+   xDelete<IssmDouble>(beta1);
+   xDelete<IssmDouble>(phi);
 }/*}}}*/
 void Delta18oParameterizationx(FemModel* femmodel){/*{{{*/
@@ -410,6 +449,4 @@
 	//    surface runoff (m/yr water equivalent): runoff
 	//    OUTPUT: mass-balance (m/yr ice): agd(NA)
-	bool isclimatology;
-	femmodel->parameters->FindParam(&isclimatology,SmbIsclimatologyEnum);
 
 	/*Loop over all the elements of this partition*/
@@ -425,67 +462,7 @@
 
 		/*Recover Smb Components*/
-		if(isclimatology){
-
-			int offsetend;
-			IssmDouble time0,timeend,timeclim;
-			IssmDouble time,starttime,finaltime;
-
-			/*Get time parameters*/
-			femmodel->parameters->FindParam(&time,TimeEnum);
-			femmodel->parameters->FindParam(&finaltime,TimesteppingFinalTimeEnum);
-			femmodel->parameters->FindParam(&starttime,TimesteppingStartTimeEnum);
-
-			//If this is a climatology, we need to repeat the forcing after the final time
-			TransientInput* acc_input    = element->inputs->GetTransientInput(SmbAccumulationEnum); _assert_(acc_input);
-			TransientInput* evap_input   = element->inputs->GetTransientInput(SmbEvaporationEnum);  _assert_(evap_input);
-			TransientInput* runoff_input = element->inputs->GetTransientInput(SmbRunoffEnum);       _assert_(runoff_input);
-
-			//Get accumulation climatology value
-			offsetend = acc_input->GetTimeInputOffset(finaltime);
-			time0     = acc_input->GetTimeByOffset(-1);
-			timeend   = acc_input->GetTimeByOffset(offsetend);
-			timeclim  = time;
-			if(time>time0 & timeend>time0){
-				IssmDouble delta=(time-time0) - (timeend-time0)*(reCast<int,IssmDouble>((time-time0)/(timeend-time0)));
-				if(delta==0.)
-				 timeclim=timeend;
-				else
-				 timeclim=time0+delta;
-			}
-			element->GetInputListOnVerticesAtTime(acc,SmbAccumulationEnum,timeclim);
-
-			//Get evaporation climatology value
-			offsetend = evap_input->GetTimeInputOffset(finaltime);
-			time0     = evap_input->GetTimeByOffset(-1);
-			timeend   = evap_input->GetTimeByOffset(offsetend);
-			timeclim  = time;
-			if(time>time0 & timeend>time0){
-				IssmDouble delta=(time-time0) - (timeend-time0)*(reCast<int,IssmDouble>((time-time0)/(timeend-time0)));
-				if(delta==0.)
-				 timeclim=timeend;
-				else
-				 timeclim=time0+delta;
-			}
-			element->GetInputListOnVerticesAtTime(evap,SmbEvaporationEnum,timeclim);
-
-			//Get runoff climatology value
-			offsetend = runoff_input->GetTimeInputOffset(finaltime);
-			time0     = runoff_input->GetTimeByOffset(-1);
-			timeend   = runoff_input->GetTimeByOffset(offsetend);
-			timeclim  = time;
-			if(time>time0 & timeend>time0){
-				IssmDouble delta=(time-time0) - (timeend-time0)*(reCast<int,IssmDouble>((time-time0)/(timeend-time0)));
-				if(delta==0.)
-				 timeclim=timeend;
-				else
-				 timeclim=time0+delta;
-			}
-			element->GetInputListOnVerticesAtTime(runoff,SmbRunoffEnum,timeclim);
-		}
-		else{
-			element->GetInputListOnVertices(acc,SmbAccumulationEnum);
-			element->GetInputListOnVertices(evap,SmbEvaporationEnum);
-			element->GetInputListOnVertices(runoff,SmbRunoffEnum);
-		}
+		element->GetInputListOnVertices(acc,SmbAccumulationEnum);
+		element->GetInputListOnVertices(evap,SmbEvaporationEnum);
+		element->GetInputListOnVertices(runoff,SmbRunoffEnum);
 
 		// loop over all vertices
@@ -510,6 +487,4 @@
 	//    refreeze of surface melt (m/yr water equivalent): refreeze
 	//    OUTPUT: mass-balance (m/yr ice): agd(NA)
-	bool isclimatology;
-	femmodel->parameters->FindParam(&isclimatology,SmbIsclimatologyEnum);
 
 	/*Loop over all the elements of this partition*/
@@ -526,82 +501,8 @@
 
 		/*Recover Smb Components*/
-		if (isclimatology){
-
-			int offsetend;
-			IssmDouble time0,timeend,timeclim;
-			IssmDouble time,starttime,finaltime;
-			femmodel->parameters->FindParam(&time,TimeEnum);
-			femmodel->parameters->FindParam(&finaltime,TimesteppingFinalTimeEnum);
-			femmodel->parameters->FindParam(&starttime,TimesteppingStartTimeEnum);
-
-
-			//If this is a climatology, we need to repeat the forcing after the final time
-			TransientInput* acc_input      = element->inputs->GetTransientInput(SmbAccumulationEnum); _assert_(acc_input);
-			TransientInput* evap_input     = element->inputs->GetTransientInput(SmbEvaporationEnum);  _assert_(evap_input);
-			TransientInput* melt_input     = element->inputs->GetTransientInput(SmbMeltEnum);         _assert_(melt_input);
-			TransientInput* refreeze_input = element->inputs->GetTransientInput(SmbRefreezeEnum);     _assert_(refreeze_input);
-
-			//Get accumulation climatology value
-			offsetend = acc_input->GetTimeInputOffset(finaltime);
-			time0     = acc_input->GetTimeByOffset(-1);
-			timeend   = acc_input->GetTimeByOffset(offsetend);
-			timeclim  = time;
-			if(time>time0 & timeend>time0){
-				IssmDouble delta=(time-time0) - (timeend-time0)*(reCast<int,IssmDouble>((time-time0)/(timeend-time0)));
-				if(delta==0.)
-				 timeclim=timeend;
-				else
-				 timeclim=time0+delta;
-			}
-			element->GetInputListOnVerticesAtTime(acc,SmbAccumulationEnum,timeclim);
-
-			//Get evaporation climatology value
-			offsetend = evap_input->GetTimeInputOffset(finaltime);
-			time0     = evap_input->GetTimeByOffset(-1);
-			timeend   = evap_input->GetTimeByOffset(offsetend);
-			timeclim  = time;
-			if(time>time0 & timeend>time0){
-				IssmDouble delta=(time-time0) - (timeend-time0)*(reCast<int,IssmDouble>((time-time0)/(timeend-time0)));
-				if(delta==0.)
-				 timeclim=timeend;
-				else
-				 timeclim=time0+delta;
-			}
-			element->GetInputListOnVerticesAtTime(evap,SmbEvaporationEnum,timeclim);
-
-			//Get melt climatology value
-			offsetend = melt_input->GetTimeInputOffset(finaltime);
-			time0     = melt_input->GetTimeByOffset(-1);
-			timeend   = melt_input->GetTimeByOffset(offsetend);
-			timeclim  = time;
-			if(time>time0 & timeend>time0){
-				IssmDouble delta=(time-time0) - (timeend-time0)*(reCast<int,IssmDouble>((time-time0)/(timeend-time0)));
-				if(delta==0.)
-				 timeclim=timeend;
-				else
-				 timeclim=time0+delta;
-			}
-			element->GetInputListOnVerticesAtTime(melt,SmbMeltEnum,timeclim);
-
-			//Get refreeze climatology value
-			offsetend = refreeze_input->GetTimeInputOffset(finaltime);
-			time0     = refreeze_input->GetTimeByOffset(-1);
-			timeend   = refreeze_input->GetTimeByOffset(offsetend);
-			timeclim  = time;
-			if(time>time0 & timeend>time0){
-				IssmDouble delta=(time-time0) - (timeend-time0)*(reCast<int,IssmDouble>((time-time0)/(timeend-time0)));
-				if(delta==0.)
-				 timeclim=timeend;
-				else
-				 timeclim=time0+delta;
-			}
-			element->GetInputListOnVerticesAtTime(refreeze,SmbRefreezeEnum,timeclim);
-		}
-		else{
-			element->GetInputListOnVertices(acc,SmbAccumulationEnum);
-			element->GetInputListOnVertices(evap,SmbEvaporationEnum);
-			element->GetInputListOnVertices(melt,SmbMeltEnum);
-			element->GetInputListOnVertices(refreeze,SmbRefreezeEnum);
-		}
+		element->GetInputListOnVertices(acc,SmbAccumulationEnum);
+		element->GetInputListOnVertices(evap,SmbEvaporationEnum);
+		element->GetInputListOnVertices(melt,SmbMeltEnum);
+		element->GetInputListOnVertices(refreeze,SmbRefreezeEnum);
 
 		// loop over all vertices
Index: issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.h
===================================================================
--- issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.h	(revision 25994)
+++ issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.h	(revision 26744)
@@ -13,4 +13,6 @@
 void SmbGradientsx(FemModel* femmodel);
 void SmbGradientsElax(FemModel* femmodel);
+void SmbautoregressionInitx(FemModel* femmodel);
+void Smbautoregressionx(FemModel* femmodel);
 void Delta18oParameterizationx(FemModel* femmodel);
 void MungsmtpParameterizationx(FemModel* femmodel);
@@ -28,10 +30,11 @@
 void       GembgridInitialize(IssmDouble** pdz, int* psize, IssmDouble zTop, IssmDouble dzTop, IssmDouble zMax, IssmDouble zY);
 IssmDouble Marbouty(IssmDouble T, IssmDouble d, IssmDouble dT);
+IssmDouble gardnerAlb(IssmDouble* re, IssmDouble* dz, IssmDouble* d, IssmDouble clabSnow, IssmDouble clabIce, IssmDouble SZA, IssmDouble COT, IssmDouble dPHC, int m);
 void grainGrowth(IssmDouble** pre, IssmDouble** pgdn, IssmDouble** pgsp, IssmDouble* T,IssmDouble* dz,IssmDouble* d, IssmDouble* W,IssmDouble smb_dt,int m,int aIdx, int sid);
-void albedo(IssmDouble** a,int aIdx, IssmDouble* re, IssmDouble* dz, IssmDouble* d, IssmDouble cldFrac, IssmDouble aIce, IssmDouble aSnow, IssmDouble aValue, IssmDouble adThresh, IssmDouble* T, IssmDouble* W, IssmDouble P, IssmDouble EC, IssmDouble Msurf, IssmDouble t0wet, IssmDouble t0dry, IssmDouble K, IssmDouble dt, IssmDouble dIce, int m, int sid);
-void shortwave(IssmDouble** pswf, int swIdx, int aIdx, IssmDouble dsw, IssmDouble as, IssmDouble* d, IssmDouble* dz, IssmDouble* re, IssmDouble dIce, int m, int sid);
-void thermo(IssmDouble* pEC, IssmDouble** T, IssmDouble* pulwrf, IssmDouble* dz, IssmDouble* d, IssmDouble* swf, IssmDouble dlw, IssmDouble Ta, IssmDouble V, IssmDouble eAir, IssmDouble pAir, IssmDouble teValue, IssmDouble Ws, IssmDouble dt0, int m, IssmDouble Vz, IssmDouble Tz, IssmDouble thermo_scaling, IssmDouble dIce, int sid, bool isconstrainsurfaceT);
-void accumulation(IssmDouble** pT, IssmDouble** pdz, IssmDouble** pd, IssmDouble** pW, IssmDouble** pa, IssmDouble** pre, IssmDouble** pgdn, IssmDouble** pgsp, int* pm, int aIdx, int dsnowIdx, IssmDouble Tmean, IssmDouble Ta, IssmDouble P, IssmDouble dzMin, IssmDouble aSnow, IssmDouble C, IssmDouble V, IssmDouble Vmean, IssmDouble dIce, int sid);
-void melt(IssmDouble* pM, IssmDouble* pMs, IssmDouble* pR, IssmDouble* pmAdd, IssmDouble* pdz_add, IssmDouble** pT, IssmDouble** pd, IssmDouble** pdz, IssmDouble** pW, IssmDouble** pa, IssmDouble** pre, IssmDouble** pgdn, IssmDouble** pgsp, int* pn, IssmDouble dzMin, IssmDouble zMax, IssmDouble zMin, IssmDouble zTop, IssmDouble zY, IssmDouble dIce, int sid);
+void albedo(IssmDouble** a, IssmDouble** adiff, int aIdx, IssmDouble* re, IssmDouble* dz, IssmDouble* d, IssmDouble cldFrac, IssmDouble aIce, IssmDouble aSnow, IssmDouble aValue, IssmDouble adThresh, IssmDouble* T, IssmDouble* W, IssmDouble P, IssmDouble EC, IssmDouble Msurf, IssmDouble clabSnow, IssmDouble clabIce, IssmDouble SZA, IssmDouble COT, IssmDouble t0wet, IssmDouble t0dry, IssmDouble K, IssmDouble dt, IssmDouble dIce, int m, int sid);
+void shortwave(IssmDouble** pswf, int swIdx, int aIdx, IssmDouble dsw, IssmDouble dswdiff, IssmDouble as, IssmDouble asdiff, IssmDouble* d, IssmDouble* dz, IssmDouble* re, IssmDouble dIce, int m, int sid);
+void thermo(IssmDouble* pEC, IssmDouble** T, IssmDouble* pulwrf, IssmDouble* re, IssmDouble* dz, IssmDouble* d, IssmDouble* swf, IssmDouble dlw, IssmDouble Ta, IssmDouble V, IssmDouble eAir, IssmDouble pAir, IssmDouble eIdx, IssmDouble teValue, IssmDouble dulwrfValue, IssmDouble teThresh, IssmDouble Ws, IssmDouble dt0, int m, IssmDouble Vz, IssmDouble Tz, IssmDouble thermo_scaling, IssmDouble dIce, int sid, bool isconstrainsurfaceT, bool isdeltaLWup);
+void accumulation(IssmDouble** pT, IssmDouble** pdz, IssmDouble** pd, IssmDouble** pW, IssmDouble** pa, IssmDouble** padiff, IssmDouble** pre, IssmDouble** pgdn, IssmDouble** pgsp, IssmDouble* pRa, int* pm, int aIdx, int dsnowIdx, IssmDouble Tmean, IssmDouble Ta, IssmDouble P, IssmDouble dzMin, IssmDouble aSnow, IssmDouble C, IssmDouble V, IssmDouble Vmean, IssmDouble dIce, int sid);
+void melt(IssmDouble* pM, IssmDouble* pMs, IssmDouble* pR, IssmDouble* pF, IssmDouble* pmAdd, IssmDouble* pdz_add, IssmDouble** pT, IssmDouble** pd, IssmDouble** pdz, IssmDouble** pW, IssmDouble** pa, IssmDouble** padiff, IssmDouble** pre, IssmDouble** pgdn, IssmDouble** pgsp, int* pn, IssmDouble Ra, IssmDouble dzMin, IssmDouble zMax, IssmDouble zMin, IssmDouble zTop, IssmDouble zY, IssmDouble dIce, int sid);
 void densification(IssmDouble** pd,IssmDouble** pdz, IssmDouble* T, IssmDouble* re, int denIdx, int aIdx, int swIdx, IssmDouble adThresh, IssmDouble C, IssmDouble dt, IssmDouble Tmean, IssmDouble dIce, int m, int sid);
 void turbulentFlux(IssmDouble* pshf, IssmDouble* plhf, IssmDouble* pEC, IssmDouble Ta, IssmDouble Ts, IssmDouble V, IssmDouble eAir, IssmDouble pAir, IssmDouble ds, IssmDouble Ws, IssmDouble Vz, IssmDouble Tz, IssmDouble dIce, int sid);
Index: issm/trunk/src/c/modules/SurfaceRelVelMisfitx/SurfaceRelVelMisfitx.cpp
===================================================================
--- issm/trunk/src/c/modules/SurfaceRelVelMisfitx/SurfaceRelVelMisfitx.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/SurfaceRelVelMisfitx/SurfaceRelVelMisfitx.cpp	(revision 26744)
@@ -63,12 +63,24 @@
 	/*Retrieve all inputs we will be needing: */
 	DatasetInput* weights_input=topelement->GetDatasetInput(InversionCostFunctionsCoefficientsEnum); _assert_(weights_input);
-	Input* vx_input     =topelement->GetInput(VxEnum);                                 _assert_(vx_input);
-	Input* vxobs_input  =topelement->GetInput(InversionVxObsEnum);                     _assert_(vxobs_input);
-	Input* vy_input     = NULL;
-	Input* vyobs_input  = NULL;
-	if(numcomponents==2){
-		vy_input    =topelement->GetInput(VyEnum);              _assert_(vy_input);
-		vyobs_input =topelement->GetInput(InversionVyObsEnum);  _assert_(vyobs_input);
+   Input* vx_input     = NULL;
+   Input* vxobs_input  = topelement->GetInput(InversionVxObsEnum);   _assert_(vxobs_input);
+   Input* vy_input     = NULL;
+   Input* vyobs_input  = NULL;
+
+   /*Read SurfaceEnum from 2D models:SSA, L1L2, MLHO*/
+   if (domaintype == Domain2DhorizontalEnum) {
+      vx_input = topelement->GetInput(VxSurfaceEnum);             _assert_(vx_input);
+      if(numcomponents==2){
+         vy_input    =topelement->GetInput(VySurfaceEnum);        _assert_(vy_input);
+         vyobs_input =topelement->GetInput(InversionVyObsEnum);   _assert_(vyobs_input);
+      }
 	}
+   else {
+      vx_input = topelement->GetInput(VxEnum);                    _assert_(vx_input);
+      if(numcomponents==2){
+         vy_input    =topelement->GetInput(VyEnum);               _assert_(vy_input);
+         vyobs_input =topelement->GetInput(InversionVyObsEnum);   _assert_(vyobs_input);
+      }
+   }
 
 	/* Start  looping on the number of gaussian points: */
@@ -111,5 +123,5 @@
 
 	/*clean up and Return: */
-	if(domaintype!=Domain2DhorizontalEnum){topelement->DeleteMaterials(); delete topelement;};
+	if(topelement->IsSpawnedElement()){topelement->DeleteMaterials(); delete topelement;};
 	xDelete<IssmDouble>(xyz_list);
 	delete gauss;
Index: issm/trunk/src/c/modules/modules.h
===================================================================
--- issm/trunk/src/c/modules/modules.h	(revision 25994)
+++ issm/trunk/src/c/modules/modules.h	(revision 26744)
@@ -72,4 +72,5 @@
 #include "./SurfaceAverageVelMisfitx/SurfaceAverageVelMisfitx.h"
 #include "./ModelProcessorx/ModelProcessorx.h"
+#include "./MmeToInputFromIdx/MmeToInputFromIdx.h"
 #include "./ParseToolkitsOptionsx/ParseToolkitsOptionsx.h"
 #include "./NodalValuex/NodalValuex.h"
@@ -90,4 +91,5 @@
 #include "./Scotchx/Scotchx.h"
 #include "./Shp2Kmlx/Shp2Kmlx.h"
+#include "./StochasticForcingx/StochasticForcingx.h"
 #include "./SurfaceMassBalancex/SurfaceMassBalancex.h"
 #include "./Solverx/Solverx.h"
@@ -102,4 +104,5 @@
 #include "./UpdateDynamicConstraintsx/UpdateDynamicConstraintsx.h"
 #include "./VertexCoordinatesx/VertexCoordinatesx.h"
+#include "./ElementCoordinatesx/ElementCoordinatesx.h"
 
 #ifdef _HAVE_OCEAN_
Index: issm/trunk/src/c/shared/Elements/PddSurfaceMassBalance.cpp
===================================================================
--- issm/trunk/src/c/shared/Elements/PddSurfaceMassBalance.cpp	(revision 25994)
+++ issm/trunk/src/c/shared/Elements/PddSurfaceMassBalance.cpp	(revision 26744)
@@ -166,6 +166,6 @@
     smf=icefac*0.001;
   }
-  snwmf=0.95*snwmf;
-  smf=0.95*smf;
+  //snwmf=0.95*snwmf;
+  //smf=0.95*smf;
 
   /*****  compute PDD ablation and refreezing *****/
